#include <QtGui>
#include <iostream>

using namespace std; 

//	class for test
class MyName
{
public :

	MyName(const QString name) { m_sname=name; };
	MyName(const MyName &other) { *this=other; };
	
	QString WhatYourName() const  { return m_sname; };
		
	MyName & operator =(const MyName &other) { m_sname=other.m_sname;return *this; };
	bool   operator<(const MyName &other) const { return (m_sname<other.WhatYourName()); };
	
private:
	QString m_sname;
};

//	dump list
void outputList(const char *title,QList<MyName> &plist )
{
	int ni;
	std::cout <<  title << std::endl;
	for(ni=0;ni<plist.count();ni++){
		std::cout << "[" <<  ni  << "]="<<  (const char*)plist.at(ni).WhatYourName().toAscii().data() << std::endl;
	}
}

//	main
int main(int /* argc */, char* /*argv[]*/ )
{
	QList<MyName> olist;
	MyName my1("test");
	MyName my2("taro");
	MyName my3("hanako");
	olist.append(my1);
	olist.append(my2);
	olist.append(my3);
	
	outputList("Not Sort",olist);
	
	//	sort
	qSort(olist);
	outputList("Sorted",olist);
	
	return 0;
}

